package weaver.formmode.customjavacode.modeexpand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.engine.kq.biz.KQFormatBiz;
import com.engine.kq.timer.KQQueue;
import com.engine.kq.timer.KQTaskBean;
import com.engine.kq.wfset.util.SplitActionUtil;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.formmode.customjavacode.AbstractModeExpandJavaCodeNew;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.soa.workflow.request.RequestInfo;


/**
 * 手动添加原始打卡记录
 */
public class AddScheduleSign extends AbstractModeExpandJavaCodeNew {
	/**
	 * 执行模块扩展动作
	 * @param param
	 *  param包含(但不限于)以下数据
	 *  user 当前用户
	 *  importtype 导入方式(仅在批量导入的接口动作会传输) 1 追加，2覆盖,3更新，获取方式(int)param.get("importtype")
     *  导入链接中拼接的特殊参数(仅在批量导入的接口动作会传输)，比如a=1，可通过param.get("a")获取参数值
	 *  页面链接拼接的参数，比如b=2,可以通过param.get("b")来获取参数
	 * @return
	 */
	public Map<String, String> doModeExpand(Map<String, Object> param) {
		Map<String, String> result = new HashMap<String, String>();
		try {
			User user = (User)param.get("user");
			int billid = -1;//数据id
			int modeid = -1;//模块id
			RequestInfo requestInfo = (RequestInfo)param.get("RequestInfo");
			if(requestInfo!=null){
				billid = Util.getIntValue(requestInfo.getRequestid());
				modeid = Util.getIntValue(requestInfo.getWorkflowid());
				if(billid>0&&modeid>0){
					//------请在下面编写业务逻辑代码------
					BaseBean bb = new BaseBean();
					bb.writeLog("AddScheduleSign Start");

					RecordSet rs = new RecordSet();
					List<List> addParams = new ArrayList<>();
					List<String> lsFormatData = new ArrayList<>();

					Map<String, String> signFromMap = new HashMap<String, String>();
					signFromMap.put( "0","e9pc");
					signFromMap.put( "1","e9mobile");
					signFromMap.put( "2","e9e");
					signFromMap.put( "3","e9ewx");
					signFromMap.put( "4","card");
					signFromMap.put( "5","e9_mobile_out");
					signFromMap.put( "6","importExcel");
					signFromMap.put( "7","EMSyn");
					signFromMap.put( "8","OutDataSourceSyn");
					signFromMap.put( "9","DingTalk");
					signFromMap.put( "10","DingTalk_out");
					signFromMap.put( "11","Wechat_out");
					signFromMap.put( "12","Wechat");

					//获取新插入的数据
					String acqSignDataSql = "select userid, usertype, signtype, signdate, signtime, clientaddress, isincom," +
							" signfrom, longitude, latitude, addr, isimport, suuid, timezone, belongdate, memo, deviceinfo, showaddress " +
							" from uf_schsignaddlog where id = ?";
					bb.writeLog("acqSignDataSql: " + acqSignDataSql);

					rs.executeQuery(acqSignDataSql, billid);
					while (rs.next()) {
						String userid = Util.null2String(rs.getString("userid"));
						String usertype = Util.null2String(rs.getString("usertype"));
						String signtype = Util.null2String(rs.getString("signtype"));
						String signdate = Util.null2String(rs.getString("signdate"));
						String signtime = Util.null2String(rs.getString("signtime"));
						String clientaddress = Util.null2String(rs.getString("clientaddress"));
						String isincom = Util.null2String(rs.getString("isincom"));
						String signfrom = Util.null2String(rs.getString("signfrom"));
						String longitude = Util.null2String(rs.getString("longitude"));
						String latitude = Util.null2String(rs.getString("latitude"));
						String addr = Util.null2String(rs.getString("addr"));
						String isimport = Util.null2String(rs.getString("isimport"));
						String suuid = Util.null2String(rs.getString("suuid"));
						String timezone = Util.null2String(rs.getString("timezone"));
						String belongdate = Util.null2String(rs.getString("belongdate"));
						String memo = Util.null2String(rs.getString("memo"));
						String deviceinfo = Util.null2String(rs.getString("deviceinfo"));
						String showaddress = Util.null2String(rs.getString("showaddress"));

						if (signtime.length() == 5) {
							signtime = signtime + ":00";
						}

						bb.writeLog("signfrom: " + signfrom);
						if (StringUtils.isNotBlank(signfrom)) {
							signfrom = signFromMap.get(signfrom);
						}
						bb.writeLog("--signfrom: " + signfrom);

						List addPa = new ArrayList<>();
						addPa.add(userid);
						addPa.add(usertype);
						addPa.add(signtype);
						addPa.add(signdate);
						addPa.add(signtime);
						addPa.add(clientaddress);
						addPa.add(isincom);
						addPa.add(signfrom);
						addPa.add(longitude);
						addPa.add(latitude);
						addPa.add(addr);
						addPa.add(isimport);
						addPa.add(suuid);
						addPa.add(timezone);
						addPa.add(belongdate);
						addPa.add(memo);
						addPa.add(deviceinfo);
						addPa.add(showaddress);
						addParams.add(addPa);

						String formatData = userid + "|" + signdate + "|" + signtime;
						if (!lsFormatData.contains(formatData)) {
							lsFormatData.add(formatData);
						}
					}
					bb.writeLog("addParams: " + addParams);

					String addSchSignSql = "insert into hrmschedulesign (userid, usertype, signtype, signdate, signtime, clientaddress, isincom, " +
							" signfrom, longitude, latitude, addr, isimport, suuid, timezone, belongdate, memo, deviceinfo, showaddress ) values " +
							" (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
					bb.writeLog("addSchSignSql: " + addSchSignSql);

					rs.executeBatchSql(addSchSignSql, addParams);

					//触发考勤格式化计算和加班
					//刷新报表数据
					List<Object> formatParams = null;
					List<List<Object>> lsFormatParams = new ArrayList<>();
					Map<String,List<String>> overtimeMap = Maps.newHashMap();
					List<String> overtimeList = Lists.newArrayList();
					bb.writeLog("开始处理考勤数据生成");
					for(int i=0;lsFormatData!=null&&i<lsFormatData.size();i++){
						formatParams = new ArrayList<>();
						String[] formatData = Util.splitString(lsFormatData.get(i),"|");
						String date_1 = weaver.common.DateUtil.addDate(formatData[1], -1);
						formatParams.add(formatData[0]);
						formatParams.add(date_1);
						lsFormatParams.add(formatParams);

						formatParams = new ArrayList<>();
						formatParams.add(formatData[0]);
						formatParams.add(formatData[1]);
						lsFormatParams.add(formatParams);

						String resourceId = formatData[0];
						String kqdate = formatData[1];
						if(overtimeMap.containsKey(resourceId)){
							List<String> tmp_overtimeList = overtimeMap.get(resourceId);
							if(!tmp_overtimeList.contains(kqdate)){
								tmp_overtimeList.add(kqdate);
							}
						}else{
							if(!overtimeList.contains(kqdate)){
								overtimeList.add(kqdate);
							}
							overtimeMap.put(resourceId, overtimeList);
						}
					}
					new KQFormatBiz().format(lsFormatParams);

					bb.writeLog("开始处理加班生成");
					//处理加班生成
					List<KQTaskBean> tasks = new ArrayList<>();
					for(Map.Entry<String, List<String>> mme: overtimeMap.entrySet()){
						String resid = mme.getKey();
						List<String> overList = mme.getValue();
						for(String date : overList){
							SplitActionUtil.pushOverTimeTasks(date,date,resid,tasks);
						}
					}
					if(!tasks.isEmpty()){
						KQQueue.writeTasks(tasks);
					}

				}
			}
		} catch (Exception e) {
			result.put("errmsg","手动添加原始打卡记录失败！");
			result.put("flag", "false");
		}
		return result;
	}

}